////////////////////////////////////////////////////////////////
// 検索ボックスガジェット
//   Copyright (C) 2008 - 2012 AAOh inc.
////////////////////////////////////////////////////////////////

/**
 * @fileOverview 検索ボックスガジェット
 * @author       $Author: fujishiro $
 */

(function () {
/**
 * searchbox。
 *
 * @namespace
 */
searchbox = {
}
})();

(function () {
/**
 * Control。
 *
 * @constructor
 */
searchbox.Control = aaoh.kaze.Gadget.extend(
	aaoh.sora.ControlEx, function() {
	// Application名。
	this.APP_NAME    = 'searchbox';
	this.APP_VERSION = '2.6.0';

	// Windowサイズ。
	this.WINDOW_ONDOCK_WIDTH         = 130 +  0;
	this.WINDOW_ONDOCK_HEIGHT        = 60 + 12;
	this.WINDOW_UNDOCK_WIDTH         = this.WINDOW_ONDOCK_WIDTH;
	this.WINDOW_UNDOCK_HEIGHT        = this.WINDOW_ONDOCK_HEIGHT;
	this.WINDOW_ONDOCK_MOBILE_WIDTH  = this.WINDOW_ONDOCK_WIDTH;
	this.WINDOW_ONDOCK_MOBILE_HEIGHT = this.WINDOW_ONDOCK_HEIGHT;
	this.WINDOW_UNDOCK_MOBILE_WIDTH  = this.WINDOW_ONDOCK_MOBILE_WIDTH;
	this.WINDOW_UNDOCK_MOBILE_HEIGHT = this.WINDOW_ONDOCK_MOBILE_HEIGHT;
	this.WINDOW_OPTION_WIDTH         = 250 +  0;
	this.WINDOW_OPTION_HEIGHT        = 220 + 12;
	this.WINDOW_OPTION_MOBILE_WIDTH  = 230 +  0;
	this.WINDOW_OPTION_MOBILE_HEIGHT = 160 + 12;

	// 検索パラメータ
	this.SEARCH_LIST = {
		name   : [
			"1", "2", "3", "4", "5", "6", "7", "8", "9", "10"
		],
		engine : []
	};
	this.SEARCH_LIST.engine['1'] = {
		"name":       "googleJp",
		"dispName":   "Google Japan",
		"icon":       "icon-images/googleJp/favicon.png",
		"url":        "http://www.google.co.jp/",
		"charset":    "utf-8",
		"searchUrl":  "http://www.google.co.jp/search?lr=lang_ja&q=",
		"suggestUrl": "http://suggestqueries.google.com/complete/search?output=firefox&hl=ja&qu="
	};
	this.SEARCH_LIST.engine['2'] = {
		"name":       "googleUs",
		"dispName":   "Google",
		"icon":       "icon-images/googleUs/favicon.png",
		"url":        "http://www.google.com/",
		"charset":    "utf-8",
		"searchUrl":  "http://www.google.com/search?q=",
		"suggestUrl": "http://suggestqueries.google.com/complete/search?output=firefox&qu="
	};
	this.SEARCH_LIST.engine['3'] = {
		"name":       "yahooJp",
		"dispName":   "Yahoo! JAPAN",
		"icon":       "icon-images/yahooJp/favicon.png",
		"url":        "http://www.yahoo.co.jp/",
		"charset":    "utf-8",
		"searchUrl":  "http://search.yahoo.co.jp/search?p=",
		"suggestUrl": "http://asprov.search.yahoo.co.jp/AssistSearchService/V2/webassistSearch?output=fxjson&p="
	};
	this.SEARCH_LIST.engine['4'] = {
		"name":       "yahooUs",
		"dispName":   "Yahoo!",
		"icon":       "icon-images/yahooUs/favicon.png",
		"url":        "http://www.yahoo.com/",
		"charset":    "utf-8",
		"searchUrl":  "http://search.yahoo.com/search?p=",
		"suggestUrl": "http://ff.search.yahoo.com/gossip?output=fxjson&command="
	};
	this.SEARCH_LIST.engine['5'] = {
		"name":       "bing",
		"dispName":   "Bing",
		"icon":       "icon-images/bing/favicon.png",
		"url":        "http://www.bing.com/",
		"charset":    "utf-8",
		"searchUrl":  "http://www.bing.com/search?q=",
		"suggestUrl": "http://api.bing.net/osjson.aspx?Market=en-us&Query="
	};
	this.SEARCH_LIST.engine['6'] = {
		"name":       "rakuten",
		"dispName":   "楽天市場",
		"icon":       "icon-images/rakuten/favicon.png",
		"url":        "http://www.rakuten.co.jp/",
		"charset":    "euc-jp",
		"searchUrl":  "http://esearch.rakuten.co.jp/rms/sd/esearch/vc?sv=2&p=0&sitem=",
		"suggestUrl": null
	};
	this.SEARCH_LIST.engine['7'] = {
		"name":       "amazonJp",
		"dispName":   "Amazon.co.jp",
		"icon":       "icon-images/amazonJp/favicon.png",
		"url":        "http://www.amazon.co.jp/",
		"charset":    "shift_jis",
		"searchUrl":  "http://www.amazon.co.jp/s/ref=nb_ss_gw?__mk_ja_JP=%83J%83%5E%83J%83i&field-keywords=",
		"suggestUrl": "http://completion.amazon.co.jp/search/complete?method=completion&search-alias=aps&mkt=6&q="
	};
	this.SEARCH_LIST.engine['8'] = {
		"name":       "amazonUs",
		"dispName":   "Amazon.com",
		"icon":       "icon-images/amazonUs/favicon.png",
		"url":        "http://www.amazon.com/",
		"charset":    "utf-8",
		"searchUrl":  "http://www.amazon.com/s?index=blended&field-keywords=",
		"suggestUrl": "http://completion.amazon.com/search/complete?method=completion&search-alias=aps&mkt=1&q="
	};
	this.SEARCH_LIST.engine['9'] = {
		"name":       "wikiJa",
		"dispName":   "Wikipedia (ja)",
		"icon":       "icon-images/wikiJa/favicon.png",
		"url":        "http://ja.wikipedia.org/",
		"charset":    "utf-8",
		"searchUrl":  "http://ja.wikipedia.org/wiki/Special:Search?search=",
		"suggestUrl": "http://ja.wikipedia.org/w/api.php?action=opensearch&search="
	};
	this.SEARCH_LIST.engine['10'] = {
		"name":       "wikiEn",
		"dispName":   "Wikipedia (en)",
		"icon":       "icon-images/wikiEn/favicon.png",
		"url":        "http://en.wikipedia.org/",
		"charset":    "utf-8",
		"searchUrl":  "http://en.wikipedia.org/wiki/Special:Search?search=",
		"suggestUrl": "http://en.wikipedia.org/w/api.php?action=opensearch&search="
	};

	// 楽天市場
	this.SEARCH_LIST.engine['6'].dispName
		= this.locale.getString('TTL_SEARCH_RAKUTEN');

	// copyright
	this.LST_IMG_NM.push('imgCopilot');
	this.LST_LNK_NM.push('lnkCopilot');
	this.LST_URL['imgCopilot'] = 'http://copilot.jp/';
	this.LST_URL['lnkCopilot'] = 'http://copilot.jp/';
})
})();

(function () {
/**
 * Model。
 *
 * @constructor
 */
searchbox.Model = aaoh.kaze.Gadget.extend(
	aaoh.sora.ModelEx, function() {
	this.data.type            = '1';
	this.data.searchEngineDef = '1';
	this.data.isSuggest       = true;
});
	/**
	 * 設定情報の読込み(iGoogle)。
	 */
	searchbox.Model.prototype.
	readDataForIGoogle = function() {
		var type            = aaoh.sora.App.control.storage.readString('type');
		var searchEngineDef = aaoh.sora.App.control.storage.readString('searchEngineDef');
		var isSuggest       = aaoh.sora.App.control.storage.readString('isSuggest');

		if (type != null) {
			this.data.type = type;
		}
		if (searchEngineDef != null) {
			this.data.searchEngineDef = searchEngineDef;
		}
		this.data.isSuggest = isSuggest;
	}

	/**
	 * 設定情報の書込み(iGoogle)。
	 */
	searchbox.Model.prototype.
	writeDataForIGoogle = function() {
		aaoh.sora.App.control.storage.writeString(
			'type', this.data.type
		);
		aaoh.sora.App.control.storage.writeString(
			'searchEngineDef', this.data.searchEngineDef
		);
		aaoh.sora.App.control.storage.writeString(
			'isSuggest', this.data.isSuggest
		);
	}
})();

(function () {
/**
 * App。
 *
 * @namespace
 */
aaoh.sora.App = {
	control: new searchbox.Control(),
	model:   new searchbox.Model(),
	main:    null,
	option:  null,

	/**
	 * 初期化。
	 *
	 * @param {String} target 初期化するターゲット
	 */
	init: function(target) {
		if (
			target != null && target == aaoh.sora.App.control.MAIN_NM
		) {
			aaoh.sora.App.main   = new searchbox.Main();
			aaoh.sora.App.option = null;

		} else if (
			target != null && target == aaoh.sora.App.control.OPTION_NM
		) {
			aaoh.sora.App.main   = null;
			aaoh.sora.App.option = new searchbox.Option();

		} else {
			aaoh.sora.App.main   = new searchbox.Main();
			aaoh.sora.App.option = new searchbox.Option();
		}

		// バージョンチェックを行う
		aaoh.sora.App.control.FLG_UPDATE = true;

		aaoh.sora.App.control.init();
	}
}
})();
